import java.net.*;

// This program sends periodically a datagram to the specified (host & port) and waits for an ack

public class udp_s_ack {
    public static void main(String args[]) throws Exception {
        if (args.length != 3) {
            System.out.println("Usage: java udp_s_ack <host> <port> <period in ms>");
            System.exit(0);
        }

        // Get the internet address of the specified host and the port number
        InetAddress address = InetAddress.getByName(args[0]);
        int port = Integer.parseInt(args[1]);
        
        // Create a socket, and send the packet through it
        DatagramSocket socket = new DatagramSocket();
        System.out.println("Sending socket created...");

        String s = new String();
        long sequence_number = 0;

        long period = Long.parseLong(args[2]);

        for (;;) {
            sequence_number++;
            Long sequence = new Long(sequence_number);
            s = sequence.toString();

            // Convert the string s to an array of bytes
            byte[] message = new byte[1024];
            message = s.getBytes();

            // Initialize the packet with data and address
            DatagramPacket packet = new DatagramPacket(message, s.length(), address, port);

            // send the packet through the socket
            System.out.println("udp_s_ack: sending message " + sequence_number);
            socket.send(packet);

            // wait for the ack
            DatagramPacket ack = new DatagramPacket(message, message.length);
            socket.receive(ack);
            // System.out.println("    udp_s_ack: received ACK message");

            // Wait for period milliseconds
            Thread.sleep(period);
        }
    }
}
